//  StructuringElement test functions
//


#include <iostream>
#include <vector>
#include "vector3d.h"
#include "se.h"

using namespace std;
using namespace i3d;

void exit();
void testArbitrary();
void testNonFlatArbitrary();
void testDiamond();
void testSquare();
void testRectangle();
void testLine();
void testPeriodicLine();
void testOctagon();
void testDisk();
void testPair();
void testBall();

int main(){

	//testArbitrary();
	//testNonFlatArbitrary();
	//testDiamond();
	//testSquare();
	//testRectangle();
	//testLine();
	testPeriodicLine();
	//testOctagon();
	//testPair();
	//testBall();
	//testDisk();
	exit();
	return 0;
}

void exit(){
	cout<<"insert some input to exit";
	int exit;
	cin >> exit;
}

void testArbitrary(){
	cout<<endl<<"testArbitrary"<<endl;
	cout<<endl<<"default arbitrary structuring element"<<endl;
	se::Arbitrary arb;
	cout<<arb<<endl;
	cout<<endl<<"arbitrary structuring element with points (0,0,0),(1,1,1),(-1,0,1)"<<endl;
	vector<Vector3d<int> > nhood;
	nhood.push_back(Vector3d<int>(1,1,0));
	nhood.push_back(Vector3d<int>(-1,0,1));
	nhood.push_back(Vector3d<int>(-1,1,1));
	nhood.push_back(Vector3d<int>(-1,-1,1));
	arb = se::Arbitrary(nhood);
	cout<<arb<<endl;
	cout<<endl<<"copy constructor and translation test with vector(-1,-1,-1)"<<endl;
	se::Arbitrary arb2 = arb;
	arb2.Translate(Vector3d<int>(-1,-1,-1));
	cout<<arb2<<endl;
	arb2.Translate(Vector3d<int>(-1,-1,-1));
	cout<<arb2<<endl;
	arb2.Translate(Vector3d<int>(-1,-1,-1));
	cout<<arb2<<endl;
	arb2.Translate(Vector3d<int>(-1,-1,-1));
	cout<<arb2<<endl;
	arb2.Translate(Vector3d<int>(-1,-1,-1));
	cout<<arb2<<endl;
	arb2.Translate(Vector3d<int>(-1,-1,-1));
	cout<<arb2<<endl;
	cout<<endl<<"reflect test on last SE"<<endl;
	arb2.Reflect();
	cout<<arb2;

}

void testNonFlatArbitrary(){
	cout<<endl<<"testNonFlatArbitrary"<<endl;
	cout<<endl<<"default  NonFlatArbitrary structuring element"<<endl;
	se::NonFlatArbitrary nfarb;
	cout<<nfarb<<endl;
	cout<<endl<<"NonFlatArbitrary structuring element with points (0,0,0),(1,1,1),(-1,0,1) and weights 3,4,5"<<endl;
	vector<Vector3d<int> > nhood;
	nhood.push_back(Vector3d<int>(0,0,0));
	nhood.push_back(Vector3d<int>(1,1,1));
	nhood.push_back(Vector3d<int>(-1,0,1));

	vector<double> weights;
	weights.push_back(3);
	weights.push_back(4);
	weights.push_back(5);
	nfarb = se::NonFlatArbitrary(nhood,weights);
	cout<<nfarb<<endl;
	//

	cout<<endl<<"copy constructor and translation test with vector(-1,-1,-1)"<<endl;
	se::NonFlatArbitrary nfarb2 = nfarb;
	nfarb2.Translate(Vector3d<int>(-1,-1,-1));
	cout<<"original:"<<nfarb<<endl;
	cout<<"translated copy:"<<nfarb2<<endl;
	cout<<endl<<"reflect test on last SE"<<endl;
	nfarb2.Reflect();
	cout<<nfarb2;

	cout<<endl<<"constructor test: short and long weights"<<endl;
	nhood.push_back(Vector3d<int>(0,-1,-1));
	nfarb = se::NonFlatArbitrary(nhood,weights);
	cout<<"short:"<<nfarb<<endl;
	weights.push_back(6);
	weights.push_back(7);
	nfarb = se::NonFlatArbitrary(nhood,weights); 
	cout<<"long:"<<nfarb<<endl;

}

void testDiamond(){
	cout<<endl<<"testDiamond"<<endl;
	cout<<se::Diamond(0)<<endl;
	cout<<se::Diamond(1)<<endl;
	cout<<se::Diamond(2)<<endl;
	cout<<se::Diamond(3)<<endl;
	cout<<se::Diamond(4)<<endl;
	cout<<se::Diamond(5)<<endl;
	cout<<se::Diamond(6)<<endl;
	cout<<se::Diamond(7)<<endl;
	cout<<se::Diamond(8)<<endl;
	cout<<se::Diamond(9)<<endl;
	cout<<endl<<"testReflect"<<endl;
	se::Diamond d(1);
	d.Reflect();
	cout<<d<<endl;
	cout<<endl<<"testTranslate"<<endl;
	d=se::Diamond(1);
	d.Translate(Vector3d<int>(1,1,0));
	cout<<d<<endl;
	cout<<endl<<"testReflectAfterTranslate"<<endl;
	d.Reflect();
	cout<<d<<endl;
}

void testSquare(){
	cout<<endl<<"testSquare"<<endl;
	cout<<endl<<"testGetNeigbourhood"<<endl;
	cout<<se::Square(1)<<endl;
	cout<<se::Square(2)<<endl;
	cout<<se::Square(3)<<endl;
	cout<<se::Square(4)<<endl;
	cout<<endl<<"testTranslate"<<endl;
	se::Square sq(3);
	sq.Translate(Vector3d<int>(1,1,0));
	cout<<sq<<endl;
	cout<<endl<<"testReflectAfterTranslate"<<endl;
	sq.Reflect();
	cout<<sq<<endl;
}

void testRectangle(){
	cout<<endl<<"testRectangle"<<endl;
	cout<<endl<<"testGetNeigbourhood"<<endl;
	cout<<se::Rectangle(0,0)<<endl;
	cout<<se::Rectangle(0,1)<<endl;
	cout<<se::Rectangle(1,1)<<endl;
	cout<<se::Rectangle(1,2)<<endl;
	cout<<se::Rectangle(2,1)<<endl;
	cout<<se::Rectangle(2,2)<<endl;
	cout<<se::Rectangle(2,3)<<endl;
	cout<<se::Rectangle(5,3)<<endl;
	cout<<se::Rectangle(3,5)<<endl<<endl;
	se::Rectangle r(3,5);
	cout<<r<<endl;
	cout<<endl<<"testTranslate"<<endl;
	r.Translate(Vector3d<int>(1,1,0));
	cout<<r<<endl;
	cout<<endl<<"test_Reflect_After_Translate"<<endl;
	r.Reflect();
	cout<<r<<endl;

}

void testLine(){
	cout<<"testLine"<<endl;

	cout<<se::Line(0,0)<<endl;
	cout<<se::Line(1,0)<<endl;
	cout<<se::Line(3,45)<<endl;
	cout<<se::Line(5,45)<<endl;
	cout<<se::Line(6,45)<<endl;
	cout<<se::Line(6,15)<<endl;
	cout<<se::Line(6,30)<<endl;
	cout<<se::Line(6,30)<<endl;
	cout<<se::Line(6,70)<<endl;
	cout<<se::Line(3,0)<<endl;
	cout<<se::Line(5,0)<<endl;
	cout<<se::Line(3,90)<<endl;
	cout<<se::Line(3,135)<<endl;
	cout<<se::Line(3,180)<<endl;
	cout<<se::Line(6,225)<<endl;
	cout<<se::Line(7,270)<<endl;
	cout<<se::Line(8,315)<<endl;
	cout<<se::Line(9,360)<<endl;

	cout<<endl<<"translate/reflect test"<<endl;
	se::Line lin(6,30);
	cout<<lin<<endl;
	lin.Reflect();
	cout<<"(reflect!) "<<lin<<endl;
	lin.Translate(Vector3d<int>(1,1,0));
	cout<<"(translate![1,1]) "<<lin<<endl;
	lin.Reflect();
	cout<<"(reflect) "<<lin<<endl;
	lin.Translate(Vector3d<int>(-1,-1,0));
	cout<<"(translate![-1,-1]) "<<lin<<endl;
}
void testPeriodicLine(){
	cout<<"test_Periodic_Line"<<endl;
	cout<<se::PeriodicLine(0,0,0)<<endl;
	cout<<se::PeriodicLine(2,-2,1)<<endl;
	cout<<se::PeriodicLine(2,1,1)<<endl;
	cout<<se::PeriodicLine(4,1,1,1)<<endl;
	
}
void testOctagon(){
	cout<<"test_Octagon"<<endl;
	cout<<se::Octagon(0)<<endl;
	cout<<se::Octagon(3)<<endl;
	//cout<<se::Octagon(6)<<endl;
	//cout<<se::Octagon(9)<<endl;
	//cout<<se::Octagon(12)<<endl;
	//cout<<se::Octagon(15)<<endl;
	//cout<<se::Octagon(18)<<endl;
	//cout<<se::Octagon(21)<<endl;
}

void testDisk(){
	cout<<"test_Disk"<<endl;
	//cout<<se::Disk(0)<<endl;
	//cout<<se::Disk(1)<<endl;
	//cout<<se::Disk(2)<<endl;
	cout<<se::Disk(5,0)<<endl;
	cout<<se::Disk(5,4)<<endl;
	cout<<se::Disk(5,6)<<endl;
	cout<<se::Disk(5,8)<<endl;
	//cout<<se::Disk(4,4)<<endl;
	//cout<<se::Disk(5,4)<<endl;
	//cout<<se::Disk(6,4)<<endl;
	//cout<<se::Disk(7,0)<<endl;
	//cout<<se::Disk(8,0)<<endl;
	//cout<<se::Disk(9,0)<<endl;
	//cout<<se::Disk(10,0)<<endl;
	//cout<<se::Disk(11,0)<<endl;
}

void testBall(){
	cout<<"test_Ball"<<endl;
	cout<<se::Ball(3,1.0)<<endl;


}

void testPair(){
		cout<<"test_Pair"<<endl;

		cout<<se::Pair()<<endl;
		cout<<se::Pair(0,0,0)<<endl;
		cout<<se::Pair(1,1,0)<<endl;
		cout<<se::Pair(2,2,0)<<endl;
		cout<<se::Pair(-2,-2,0)<<endl;
		cout<<se::Pair(-3,1,0)<<endl;
		cout<<se::Pair(1,-6,0)<<endl;
}
